#pragma once
#include "base_expression.hpp"
#include "utilities.hpp"

namespace swer
{

    /**
    Represents an array in Swer, which has elements in form of expressions.
    */
    class array : public base_expression
    {
    public:
        explicit array(base_expression_ptr&& elements) : m_elements(std::move(elements))
        {
        }

        std::string as_string() const override
        {
            auto expression_list = std::dynamic_pointer_cast<expression>(m_elements);
            return concat("Vector<decltype(", expression_list->first_expression()->as_string(), ")>{", m_elements->as_string(), "}");
        }

    private:
        base_expression_ptr m_elements;
    };
}
