﻿#include "base_declaration.hpp"
#include "variable_declaration.hpp"
#include "function_declaration.hpp"
#include "class_declaration.hpp"

std::shared_ptr<swer::class_declaration> swer::base_declaration::as_class(const base_declaration_ptr& ptr)
{
    return std::dynamic_pointer_cast<class_declaration>(ptr);
}

std::shared_ptr<swer::variable_declaration> swer::base_declaration::as_variable(const base_declaration_ptr& ptr)
{
    return std::dynamic_pointer_cast<variable_declaration>(ptr);
}

std::shared_ptr<swer::function_declaration> swer::base_declaration::as_function(const base_declaration_ptr& ptr)
{
    return std::dynamic_pointer_cast<function_declaration>(ptr);
}

