﻿#pragma once
#include <memory>
#include <vector>

namespace swer
{
    /**
        Represents an expression in Swer. All expression derive from this struct.
    */
    struct base_expression
    {
        /**
            String representation of the expression. Derived classes overrides this method to provide implementation.
        */
        virtual std::string as_string() const = 0;
        virtual ~base_expression() = default;
    };

    using base_expression_ptr = std::shared_ptr<base_expression>;
    using base_expression_seq = std::vector<base_expression_ptr>;
}
