#pragma once
#include <algorithm>
#include <string>

#include "base_statement.hpp"
#include "utilities.hpp"

namespace swer
{
    /**
    Represents sequence of statements in braces: { stmt; }
    */
    class compound_statement : public base_statement
    {
    public:
        compound_statement()
        {
        }

        explicit compound_statement(base_statement_seq&& statement) : m_statements(std::move(statement))
        {
        }

        std::string as_string() const override
        {
            return concat(
                "{\n",
                string_join(m_statements, "", as_string_decay<base_statement_ptr>),
                "\n}\n"
            );
        }

    private:
        base_statement_seq m_statements;
    };
}
