﻿#include "expression.hpp"
using swer::operator_t;

std::shared_ptr<operator_t> operator_t::expression = std::make_shared<operator_t>(operator_t::type::EXPRESSION);

std::shared_ptr<operator_t> operator_t::addition = std::make_shared<operator_t>(operator_t::type::ADDITION);
std::shared_ptr<operator_t> operator_t::subtraction = std::make_shared<operator_t>(operator_t::type::SUBTRACTION);
std::shared_ptr<operator_t> operator_t::multiplication = std::make_shared<operator_t>(operator_t::type::MULTIPLICATION);
std::shared_ptr<operator_t> operator_t::division = std::make_shared<operator_t>(operator_t::type::DIVISION);
std::shared_ptr<operator_t> operator_t::modulation = std::make_shared<operator_t>(operator_t::type::MODULATION);
std::shared_ptr<operator_t> operator_t::exponentiation = std::make_shared<operator_t>(operator_t::type::EXPONENTIATION);
std::shared_ptr<operator_t> operator_t::unary_plus = std::make_shared<operator_t>(operator_t::type::UNARY_PLUS);
std::shared_ptr<operator_t> operator_t::unary_minus = std::make_shared<operator_t>(operator_t::type::UNARY_MINUS);
std::shared_ptr<operator_t> operator_t::pre_increment = std::make_shared<operator_t>(operator_t::type::PRE_INCREMENT);
std::shared_ptr<operator_t> operator_t::pre_decrement = std::make_shared<operator_t>(operator_t::type::PRE_DECREMENT);
std::shared_ptr<operator_t> operator_t::post_increment = std::make_shared<operator_t>(operator_t::type::POST_INCREMENT);
std::shared_ptr<operator_t> operator_t::post_decrement = std::make_shared<operator_t>(operator_t::type::POST_DECREMENT);
std::shared_ptr<operator_t> operator_t::factorial = std::make_shared<operator_t>(operator_t::type::FACTORIAL);

std::shared_ptr<operator_t> operator_t::assignment = std::make_shared<operator_t>(operator_t::type::ASSIGNMENT);
std::shared_ptr<operator_t> operator_t::addition_assignment = std::make_shared<operator_t>(operator_t::type::ADDITION_ASSIGNMENT);
std::shared_ptr<operator_t> operator_t::subtraction_assignment = std::make_shared<operator_t>(operator_t::type::SUBTRACTION_ASSIGNMENT);
std::shared_ptr<operator_t> operator_t::multiplication_assignment = std::make_shared<operator_t>(operator_t::type::MULTIPLICATION_ASSIGNMENT);
std::shared_ptr<operator_t> operator_t::division_assignment = std::make_shared<operator_t>(operator_t::type::DIVISION_ASSIGNMENT);
std::shared_ptr<operator_t> operator_t::modulation_assignment = std::make_shared<operator_t>(operator_t::type::MODULATION_ASSIGNMENT);
std::shared_ptr<operator_t> operator_t::exponentiation_assignment = std::make_shared<operator_t>(operator_t::type::EXPONENTIATION_ASSIGNMENT);
std::shared_ptr<operator_t> operator_t::left_shift_assignment = std::make_shared<operator_t>(operator_t::type::LEFT_SHIFT_ASSIGNMENT);
std::shared_ptr<operator_t> operator_t::right_shift_assignment = std::make_shared<operator_t>(operator_t::type::RIGHT_SHIFT_ASSIGNMENT);
std::shared_ptr<operator_t> operator_t::bitwise_and_assignment = std::make_shared<operator_t>(operator_t::type::BITWISE_AND_ASSIGNMENT);
std::shared_ptr<operator_t> operator_t::bitwise_or_assignment = std::make_shared<operator_t>(operator_t::type::BITWISE_OR_ASSIGNMENT);
std::shared_ptr<operator_t> operator_t::bitwise_xor_assignment = std::make_shared<operator_t>(operator_t::type::BITWISE_XOR_ASSIGNMENT);

std::shared_ptr<operator_t> operator_t::logical_not = std::make_shared<operator_t>(operator_t::type::LOGICAL_NOT);
std::shared_ptr<operator_t> operator_t::logical_and = std::make_shared<operator_t>(operator_t::type::LOGICAL_AND);
std::shared_ptr<operator_t> operator_t::logical_or = std::make_shared<operator_t>(operator_t::type::LOGICAL_OR);
std::shared_ptr<operator_t> operator_t::bitwise_not = std::make_shared<operator_t>(operator_t::type::BITWISE_NOT);
std::shared_ptr<operator_t> operator_t::bitwise_and = std::make_shared<operator_t>(operator_t::type::BITWISE_AND);
std::shared_ptr<operator_t> operator_t::bitwise_or = std::make_shared<operator_t>(operator_t::type::BITWISE_OR);
std::shared_ptr<operator_t> operator_t::bitwise_xor = std::make_shared<operator_t>(operator_t::type::BITWISE_XOR);
std::shared_ptr<operator_t> operator_t::left_shift = std::make_shared<operator_t>(operator_t::type::LEFT_SHIFT);
std::shared_ptr<operator_t> operator_t::right_shift = std::make_shared<operator_t>(operator_t::type::RIGHT_SHIFT);

std::shared_ptr<operator_t> operator_t::conditional = std::make_shared<operator_t>(operator_t::type::CONDITIONAL);
std::shared_ptr<operator_t> operator_t::less = std::make_shared<operator_t>(operator_t::type::LESS);
std::shared_ptr<operator_t> operator_t::greater = std::make_shared<operator_t>(operator_t::type::GREATER);
std::shared_ptr<operator_t> operator_t::less_equals = std::make_shared<operator_t>(operator_t::type::LESS_EQUALS);
std::shared_ptr<operator_t> operator_t::greater_equals = std::make_shared<operator_t>(operator_t::type::GREATER_EQUALS);
std::shared_ptr<operator_t> operator_t::equals = std::make_shared<operator_t>(operator_t::type::EQUALS);
std::shared_ptr<operator_t> operator_t::not_equals = std::make_shared<operator_t>(operator_t::type::NOT_EQUALS);

std::shared_ptr<operator_t> operator_t::address_of = std::make_shared<operator_t>(operator_t::type::ADDRESS_OF);
std::shared_ptr<operator_t> operator_t::dereference = std::make_shared<operator_t>(operator_t::type::DEREFERENCE);
std::shared_ptr<operator_t> operator_t::member_access_dot = std::make_shared<operator_t>(operator_t::type::MEMBER_ACCESS_DOT);
std::shared_ptr<operator_t> operator_t::member_access_right_arrow = std::make_shared<operator_t>(operator_t::type::MEMBER_ACCESS_RIGHT_ARROW);
std::shared_ptr<operator_t> operator_t::subscript = std::make_shared<operator_t>(operator_t::type::SUBSCRIPT);
std::shared_ptr<operator_t> operator_t::function_call = std::make_shared<operator_t>(operator_t::type::FUNCTION_CALL);
std::shared_ptr<operator_t> operator_t::expr_list = std::make_shared<operator_t>(operator_t::type::EXPR_LIST);
std::shared_ptr<operator_t> operator_t::braced_list = std::make_shared<operator_t>(operator_t::type::BRACED_LIST);

std::string swer::operator_object::operator_symbol(swer::operator_object::operator_type type)
{
    static std::unordered_map<swer::operator_object::operator_type, std::string> mapping {
        { swer::operator_object::operator_type::PLUS, "+" },
        { swer::operator_object::operator_type::MINUS, "-" },
        { swer::operator_object::operator_type::MULTI, "*" },
        { swer::operator_object::operator_type::DIVIDE, "/" },
        { swer::operator_object::operator_type::MODULO, "%" },
        { swer::operator_object::operator_type::EXPONENT, "^" }
    };
    try
    {
        return mapping.at(type);
    }
    catch (std::out_of_range&)
    {
        throw std::runtime_error("Added new operator_type without text representation.");
    }
}

