#include <string>
#include "function_declaration.hpp"
#include "class_declaration.hpp"

std::string swer::function_declaration::define(swer::class_declarations& classes) const
{
    std::string str;
    str += concat(
        string_join(classes, "", [](const class_declaration* c) { return template_args_decl(c->generic_identifiers()); }),
        m_ret_type->as_string(), " "
    );
    
    for (const class_declaration* c : classes)
        str += concat(c->class_name(), template_args_use(c->generic_identifiers()), "::");

    str += concat(m_identifier, "(", string_join(m_formal_parameters, ", ", [](const formal_parameter_ptr& param)
        {
            return param->as_string_no_init();
        }), ")\n", m_body->as_string(), "\n"
    );
    return str;
}
