#pragma once
#include <string>
#include "base_expression.hpp"

namespace swer
{
    /**
    Represents an identifier in Swer. Contains just name of the identifier.
    */
    class identifier : public base_expression
    {
    public:
        explicit identifier(std::string&& identifier) : m_identifier(std::move(identifier))
        {
        }

        std::string as_string() const override
        {
            return m_identifier;
        }

    private:
        std::string m_identifier;
    };
}
