#pragma once
#include <string>

#include "base_statement.hpp"

namespace swer
{
    /**
    Is base class for all iteration statements in Swer.
    */
    class iteration_statement : public base_statement
    {
    public:
        std::string as_string() const override = 0;
        ~iteration_statement() override = default;

        explicit iteration_statement(base_statement_ptr&& body) : m_body(std::move(body))
        {
        }

    protected:
        base_statement_ptr m_body;
    };

}
