﻿#pragma once
#include <string>
#include <memory>
#include <typeinfo>

#include "base_statement.hpp"
#include "expression.hpp"
#include "compiler.hpp"
#include "error.hpp"

namespace swer
{
    /**
        Represents plain statement, that is either variable declaration of expression specified by template parameter.
    */
    template<typename Base>
    class plain_statement : public base_statement
    {
        using base_ptr = std::shared_ptr<Base>;
    public:
        explicit plain_statement(base_ptr&& base) : m_base(std::move(base))
        {
        }

        std::string as_string() const override
        {
            return concat(m_base->as_string(), ";\n");
        }

    private:
        base_ptr m_base;
    };
}
