#pragma once
#include <memory>

namespace std_utils
{
    // Since C++14
    // Missing SFINAE overload for T[] 
    template<typename T, typename... Args>
    std::unique_ptr<T> make_unique(Args&&... args)
    {
        return std::unique_ptr<T>(new T(std::forward<Args>(args)...));
    }
}
