#pragma once
#include "base_expression.hpp"
#include "utilities.hpp"
#include "base_statement.hpp"
#include "iteration_statement.hpp"

namespace swer
{
    /**
    Represents a while statement.
    */
    class while_statement : public iteration_statement
    {
    public:
        while_statement(base_expression_ptr&& end_condition, base_statement_ptr&& body)
            : iteration_statement(std::move(body))
            , m_end_condition(std::move(end_condition))
        {
        }

        std::string as_string() const override
        {
            return concat(
                "while (", m_end_condition->as_string(), ")\n",
                m_body->as_string()
            );
        }

    private:
        base_expression_ptr m_end_condition;
    };
}
