﻿#pragma once
#include <iostream>

namespace swerstl
{
    /**
        Prints all arguments in specified order to standard output.
    */
    template<typename T, typename... Ts>
    void print(T&& arg, Ts&&... args)
    {
        std::cout << std::forward<T>(arg);
        print(std::forward<Ts>(args)...);
    }

    inline void print()
    {
    }


    /**
        Calls print with trailing line break.
    */
    template<typename... Ts>
    void p(Ts&&... args)
    {
        print(std::forward<Ts>(args)..., "\n");
    }

    /**
        Call print.
    */
    template<typename... Ts>
    void pr(Ts&&... args)
    {
        print(std::forward<Ts>(args)...);
    }
}
