package cz.cuni.mff.d3s.benchmarks;

import java.util.Random;

public class VirtualCalls
{
    private interface Base { int method(); }
    private class Impl0 implements Base { public int method() { return 0; } }
    private class Impl1 implements Base { public int method() { return 1; } }
    private class Impl2 implements Base { public int method() { return 2; } }
    private class Impl3 implements Base { public int method() { return 3; } }
    private class Impl4 implements Base { public int method() { return 4; } }
    private class Impl5 implements Base { public int method() { return 5; } }
    private class Impl6 implements Base { public int method() { return 6; } }
    private class Impl7 implements Base { public int method() { return 7; } }
    private class Impl8 implements Base { public int method() { return 8; } }
    private class Impl9 implements Base { public int method() { return 9; } }

    Base get_impl(int index)
    {
        switch (index)
        {
            case 0: return new Impl0();
            case 1: return new Impl1();
            case 2: return new Impl2();
            case 3: return new Impl3();
            case 4: return new Impl4();
            case 5: return new Impl5();
            case 6: return new Impl6();
            case 7: return new Impl7();
            case 8: return new Impl8();
            case 9: return new Impl9();
        }
        return null;
    }

    public static void main(String[] args)
    {
        int call_count = 1000000;
        int re_pool = 10;
        int pool_size = 100;

        if (args.length > 0)
            call_count = Integer.parseInt(args[0]);
        if (args.length > 1)
            re_pool = Integer.parseInt(args[1]);
        if (args.length > 2)
            pool_size = Integer.parseInt(args[2]);

        Random r = new Random();
        for (int i = 0; i < re_pool; ++i)
        {
            Base[] pool = new Base[pool_size];
            for (int j = 0; j < pool_size; ++j)
                pool[j] = new VirtualCalls().get_impl(r.nextInt(10));

            int sink = 0;
            for (int j = 0; j < call_count / re_pool; ++j)
                sink += pool[r.nextInt(pool.length)].method();
            System.out.println(sink);
        }
    }
}
