#!/bin/bash

COUNT=15

run_none()
{
    FILE=results/$1.none.txt
    rm -f $FILE
    for i in `seq $COUNT`; do
        ./run_none_benchmark.sh $1 $2 2>> $FILE
    done
}

run_events()
{
    FILE=results/$1.events.txt
    rm -f $FILE
    for i in `seq $COUNT`; do
        ./run_events_benchmark.sh $1 $2 2>> $FILE
    done
}

run_bci_all()
{
    FILE=results/$1.bci.all.txt
    rm -f $FILE
    for i in `seq $COUNT`; do
        ./run_bci_benchmark.sh "" $1 $2 2>> $FILE
    done
}

run_bciinfo_all()
{
    FILE=results/$1.bciinfo.all.txt
    rm -f $FILE
    for i in `seq $COUNT`; do
        ./run_bci_info_benchmark.sh "" $1 $2 2>> $FILE
    done
}

run_bci_VirtualCalls()
{
    FILE=results/VirtualCalls.bci.txt
    rm -f $FILE
    for i in `seq $COUNT`; do
        ./run_bci_benchmark.sh cz.cuni.mff.d3s.benchmarks VirtualCalls 2>> $FILE
    done
}

run_bciinfo_VirtualCalls()
{
    FILE=results/VirtualCalls.bciinfo.txt
    rm -f $FILE
    for i in `seq $COUNT`; do
        ./run_bci_info_benchmark.sh cz.cuni.mff.d3s.benchmarks VirtualCalls 2>> $FILE
    done
}

run_bci_Zip()
{
    FILE=results/Zip.bci.txt
    rm -f $FILE
    for i in `seq $COUNT`; do
        ./run_bci_benchmark.sh org.zeroturnaround Zip $1 2>> $FILE
    done
}

run_bciinfo_Zip()
{
    FILE=results/Zip.bciinfo.txt
    rm -f $FILE
    for i in `seq $COUNT`; do
        ./run_bci_info_benchmark.sh org.zeroturnaround Zip $1 2>> $FILE
    done
}

run_bci_MatrixMultiplication()
{
    FILE=results/MatrixMultiplication.bci.txt
    rm -f $FILE
    for i in `seq $COUNT`; do
        ./run_bci_benchmark.sh org.ejml MatrixMultiplication 2>> $FILE
    done
}


mkdir -p results

run_none VirtualCalls
run_events VirtualCalls
run_bci_all VirtualCalls
run_bciinfo_all VirtualCalls
run_bci_VirtualCalls
run_bciinfo_VirtualCalls

run_none Zip ./data/BP.zip
run_events Zip ./data/BP.zip
run_bci_all Zip ./data/BP.zip
run_bciinfo_all Zip ./data/BP.zip
run_bci_Zip ./data/BP.zip
run_bciinfo_Zip ./data/BP.zip

run_none MatrixMultiplication
run_events MatrixMultiplication
run_bci_all MatrixMultiplication
run_bci_MatrixMultiplication
