﻿#pragma once
#include "platform.hpp"

#include <string>
#include <vector>

#ifdef PLATFORM_WIN
  #include <windows.h>
#endif

namespace nonstd
{
    class process
    {
    public:
        process(const std::string& exe, const std::vector<std::string>& args, bool delayed_start = false);
        ~process();

        void start();
        bool started() const;
        void stop() const;
        void join() const;
    private:
        std::string exe;
        std::vector<std::string> args;

#ifdef PLATFORM_WIN
        STARTUPINFO startup_info;
        PROCESS_INFORMATION process_info;
#endif // PLATFORM_WIN

#ifdef PLATFORM_UNIX
        int pid;
#endif // PLATFORM_UNIX
    };
} // namespace nonstd

#include "windows/processes_impl.hpp"
#include "unix/processes_impl.hpp"
