package cz.cuni.mff.d3s;

import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.MethodVisitor;
import org.objectweb.asm.Opcodes;

public class AddJVMTIMethodHooks extends ClassVisitor
{
    private String className;
    public AddJVMTIMethodHooks(ClassVisitor cv, String className)
    {
        super(Opcodes.ASM6, cv);

        this.className = className;
        cv.visitMethod(Opcodes.ACC_NATIVE | Opcodes.ACC_PRIVATE | Opcodes.ACC_STATIC, InstrumentationEngine.MethodEntryHookName, "()V", null, null);
        cv.visitMethod(Opcodes.ACC_NATIVE | Opcodes.ACC_PRIVATE | Opcodes.ACC_STATIC, InstrumentationEngine.MethodExitHookName, "(Ljava/lang/Object;)V", null, null);
    }

    @Override
    public MethodVisitor visitMethod(int access, String name, String desc, String signature, String[] exceptions)
    {
        MethodVisitor mv = cv.visitMethod(access, name, desc, signature, exceptions);
        MethodVisitor entry = new AddMethodEntryHook(mv, className, name);
        MethodVisitor exit = new AddMethodExitHook(entry, className);
        return exit;
    }
}
