package cz.cuni.mff.d3s;

import java.io.IOException;
import java.net.InetAddress;

public class Program
{
    public static void main(String[] args) throws IOException
    {
        BCIServer server = null;
        try
        {
            if (args.length != 2)
                throw new BCIServerException("Invalid arguments length.");

            InetAddress addr = InetAddress.getByName(args[0]);
            int port;
            try
            {
                port = Integer.parseInt(args[1]);
            }
            catch (NumberFormatException e)
            {
                throw new BCIServerException("Invalid port", e);
            }

            server = new BCIServer(addr, port);
            server.waitForConnection();
            while (server.processRequest())
            {
                //try {Thread.sleep(100);} catch (Exception e){}                
            }
        }
        catch (BCIServerException exception)
        {
            System.err.println("BCIServer failed with error: ");
            System.err.println(exception.getMessage());
        }
        finally
        {
            if (server != null)
                server.close();
        }
    }
}
